// KChannels - Keltner Channels are explained in the book The New Commodity Trading System and Methods by Perry Kaufman and were first introduced in the book How To Make Money in Commodities, by Chester W. Keltner. 

// www.onlinetradingconcepts.com/TechnicalAnalysis/KeltnerChannel.html
// stockcharts.com/help/doku.php?id=chart_school:technical_indicators:keltner_channels
// en.wikipedia.org/wiki/Keltner_channel


function init()
{
    with (KChannels) {
        createBuffer("KChannels");
        setBufferColor("KChannels", "#00FFAA");
        setBufferDrawStyle("KChannels", DrawStyle.LINE);

        createBuffer("KChannels1");
        setBufferColor("KChannels1", "#009999");
        setBufferDrawStyle("KChannels1", DrawStyle.LINE);

        createBuffer("KChannels2");
        setBufferColor("KChannels2", "#005555");
        setBufferDrawStyle("KChannels2", DrawStyle.LINE);

        setAutoChangeMaxMin("KChannels", "KChannels1", "KChannels2");

        createParameter("Period", 10);
    }
}

function start()
{
    KChannels.label = "KChannels (" + KChannels.parameter("Period") + ")";
    var num = Shared.numberOfQuotes();

    var TypicalBuf = Shared.typical();
    var HighBuf = Shared.high();
    var LowBuf = Shared.low();

    var KChannelsBuf  = Shared.ema(KChannels.parameter("Period"), TypicalBuf);

    var DeltaBuf   = new Array(num);

    for (var i = 0; i < num; ++i) { 
       DeltaBuf[i] = HighBuf[i] - LowBuf[i];    
    }

    var DeltaBufSma = Shared.ema(KChannels.parameter("Period"), DeltaBuf);

    var KChannelsBuf1 = new Array(num);
    var KChannelsBuf2 = new Array(num);


    for (var i = 0; i < num; ++i) {
        KChannelsBuf1[i] = KChannelsBuf[i] + DeltaBufSma[i];
        KChannelsBuf2[i] = KChannelsBuf[i] - DeltaBufSma[i];
    }

    KChannels.setBufferData("KChannels",  KChannelsBuf);
    KChannels.setBufferData("KChannels1", KChannelsBuf1);
    KChannels.setBufferData("KChannels2", KChannelsBuf2);
}


 